/*
   Tamot --- Task Modelling Editor
   Copyright (C) 2000 Commonwealth Scientific and Industrial Research Organisation
   (CSIRO), Australia. All rights reserved. 

   The Software, owned by CSIRO Australia, has been developed by the CSIRO 
   Intelligent Interactive Technology group. 
   For more information, please see http://www.cmis.csiro.au/iit/.

   The Software is a beta-test version for internal research and evaluation purposes 
   by the Licensee. The Software is still at a development stage. 
   It has not undergone complete testing and may have inherent errors,
   bugs or deficiencies that can affect the operation of the Software. 

   We encourage your feedback and suggestions. Any bugs / suggestions found please email to
   Shijian.Lu@cmis.csiro.au and Thomas.Lo@cmis.csiro.au. 

   After you have signed the Beta-Test Software License Agreement with the CSIRO,
   CSIRO grants you a non-exclusive, non-transferable license to use it only for your 
   personal, non-commercial and lawful end use. Implied licenses are negated. 

   Warranty Disclaimer : 

   CSIRO supplies the Software on an "as is" basis and makes no warranties that use of
   the Software by the Licensee will not infringe any third party’s 
   Intellectual Property Rights nor that the Software will be of merchantable quality,
   or suitable for a particular purpose. CSIRO excludes all terms, conditions and
   warranties implied by custom, the general law or statute in relation to the
   Software.
*/

package taskModellingTool;

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.tree.*;
import javax.swing.event.*;
import java.util.*;

public class DisplayedJTree extends JTree {
    
    protected static final String ROOT_STRING="/";
    private DefaultMutableTreeNode jroot;
    
    public DisplayedJTree() {
        super(new DefaultMutableTreeNode(ROOT_STRING));
        getSelectionModel().setSelectionMode(TreeSelectionModel.SINGLE_TREE_SELECTION);
    }
    
    public void reset() {
        setModel(new DefaultTreeModel(new DefaultMutableTreeNode(ROOT_STRING)));        
    }

    public void fill(DefaultMutableTreeNode jrootTemplate) {
        jroot = (DefaultMutableTreeNode)((DefaultTreeModel)getModel()).getRoot();

        copyTreeStructure(jroot,jrootTemplate);
    }
    
    public void construction(DefaultMutableTreeNode jcopyFrom,DefaultMutableTreeNode jcopyTo) {
        for (Enumeration e = jcopyFrom.children();e.hasMoreElements();) {
            DefaultMutableTreeNode jchild = (DefaultMutableTreeNode)e.nextElement();
            
            String childName = (String)jchild.getUserObject();
            
            DefaultMutableTreeNode jclone = new DefaultMutableTreeNode(childName);
            
            if (!jchild.isLeaf())
                construction(jchild,jclone);

            jcopyTo.add(jclone);
        }
    }

    public void copyTreeStructure(DefaultMutableTreeNode jparent,DefaultMutableTreeNode jparent_template) {
        if (jparent.equals(jparent_template)) return;

        jparent.removeAllChildren();
        
        construction(jparent_template,jparent);
        
        ((DefaultTreeModel)getModel()).reload(jparent);
    }
    
}